void G_UnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_UnshadedPerspTexturePolygon(Poly, VPage, x, y);
}

void G_AmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_AmbientPerspTexturePolygon(Poly, VPage, x, y);
}

void G_LambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_LambertPerspTexturePolygon(Poly, VPage, x, y);
}

void G_GouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_GouraudPerspTexturePolygon(Poly, VPage, x, y);
}

void G_PhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_PhongPerspTexturePolygon(Poly, VPage, x, y);
}

void G_UnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  if (PreviousState != (UNSHADED | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (UNSHADED | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_AmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (AMBIENT | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (AMBIENT | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);

  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  grConstantColorValue((a << 24));

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_LambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (LAMBERT | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (LAMBERT | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);

  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  grConstantColorValue((a << 24));

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_GouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  float GlossVal;

  if (PreviousState != (GOURAUD | PERSPTEXTURE))
    {
      PreviousState = (GOURAUD | PERSPTEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                     GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->A->Shade * 1023)]);
  A.r = A.g = A.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->A->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->B->Shade * 1023)]);
  B.r = B.g = B.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->B->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->C->Shade * 1023)]);
  C.r = C.g = C.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->C->Shade) + GlossVal);

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_PhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{}
