void G_TransUnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_TransUnshadedPerspTexturePolygon(Poly, VPage, x, y);
}

void G_TransAmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_TransAmbientPerspTexturePolygon(Poly, VPage, x, y);
}

void G_TransLambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_TransLambertPerspTexturePolygon(Poly, VPage, x, y);
}

void G_TransGouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_TransGouraudPerspTexturePolygon(Poly, VPage, x, y);
}

void G_TransPhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  G_TransPhongPerspTexturePolygon(Poly, VPage, x, y);
}

void G_TransUnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  if (PreviousState != (TRANSPARENT | UNSHADED | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (TRANSPARENT | UNSHADED | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL_ALPHA,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  grConstantColorValue(0x7f000000);

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_TransAmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (TRANSPARENT | AMBIENT | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (TRANSPARENT | AMBIENT | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);
  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  A.r = A.g = A.b = a;
  B.r = B.g = B.b = a;
  C.r = C.g = C.b = a;

  grConstantColorValue(0x7f000000);

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_TransLambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  int a;
  float GlossVal;

  if (PreviousState != (TRANSPARENT | LAMBERT | TEXTURE))
    {
      /* set color combiner and clear texture and alpha combiners */
      PreviousState = (TRANSPARENT | LAMBERT | TEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->Shade * 1023)]);
  a = (int)(pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->Shade) + GlossVal);

  A.r = A.g = A.b = a;
  B.r = B.g = B.b = a;
  C.r = C.g = C.b = a;

  grConstantColorValue(0x7f000000);

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_TransGouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{
  float GlossVal;

  if (PreviousState != (TRANSPARENT | GOURAUD | PERSPTEXTURE))
    {
      PreviousState = (TRANSPARENT | GOURAUD | PERSPTEXTURE);
      grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_LOCAL,
                     GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

      grAlphaCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                     GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);

      grAlphaBlendFunction(GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO);
    }

  grConstantColorValue(0x7f000000);

  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->A->Shade * 1023)]);
  A.r = A.g = A.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->A->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->B->Shade * 1023)]);
  B.r = B.g = B.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->B->Shade) + GlossVal);
  GlossVal = pSPECULAR*(GlossTable[FLT2INT(Poly->C->Shade * 1023)]);
  C.r = C.g = C.b = (pAMBIENT*(255*2.0/5.0) + pDIFFUSE*(255*Poly->C->Shade) + GlossVal);

  STD_TRI_SETUP;
  STD_TEX_SETUP;

  grDrawTriangle(&A, &B, &C);
}

void G_TransPhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y)
{}
