#ifndef POLYGONH
#define POLYGONH
#include "inertia.h"


extern "C" Vertex   *VertPtrA;
extern "C" Vertex   *VertPtrB;
extern "C" Vertex   *VertPtrC;

extern "C" Vertex2d *TVA;
extern "C" Vertex2d *TVB;
extern "C" Vertex2d *TVC;

extern "C" int      TotalHeight;
extern "C" int      TopHeight;
extern "C" int      BottomHeight;

extern "C" int      CeilY1;
extern "C" int      CeilY2;
extern "C" int      CeilY3;

extern "C" int      FXDLongX;
extern "C" int      FXDLongDX;
extern "C" int      FXDShortX;
extern "C" int      FXDShortDX;

extern "C" int      FXDSide1C;
extern "C" int      FXDSide1DC;
extern "C" int      FXDSide2C;
extern "C" int      FXDSide2DC;

extern "C" int      FXDSide1U;
extern "C" int      FXDSide1DU;
extern "C" int      FXDSide2U;
extern "C" int      FXDSide2DU;

extern "C" int      FXDSide1V;
extern "C" int      FXDSide1DV;
extern "C" int      FXDSide2V;
extern "C" int      FXDSide2DV;

extern "C" int      FXDSide1S;
extern "C" int      FXDSide1DS;
extern "C" int      FXDSide2S;
extern "C" int      FXDSide2DS;

extern "C" int      FXDSide1T;
extern "C" int      FXDSide1DT;
extern "C" int      FXDSide2T;
extern "C" int      FXDSide2DT;

extern "C" int      FXDSide1Z;
extern "C" int      FXDSide1DZ;
extern "C" int      FXDSide2Z;
extern "C" int      FXDSide2DZ;

extern "C" float    FLTInten1;
extern "C" float    FLTInten2;
extern "C" float    FLTInten3;

extern "C" float    FLTTextureX1;
extern "C" float    FLTTextureX2;
extern "C" float    FLTTextureX3;

extern "C" float    FLTTextureY1;
extern "C" float    FLTTextureY2;
extern "C" float    FLTTextureY3;

extern "C" float    FLTEnvX1;
extern "C" float    FLTEnvX2;
extern "C" float    FLTEnvX3;

extern "C" float    FLTEnvY1;
extern "C" float    FLTEnvY2;
extern "C" float    FLTEnvY3;

extern "C" float    FLTZ1;
extern "C" float    FLTZ2;
extern "C" float    FLTZ3;

extern "C" float    FLTLongDX;
extern "C" float    FLTShortDX;

extern "C" float    OneOverTotalDY;
extern "C" float    OneOverTopDY;
extern "C" float    OneOverBotDY;

extern "C" float    PolyDX;

extern "C" int      HorizontalDC;
extern "C" int      HorizontalDU;
extern "C" int      HorizontalDV;
extern "C" int      HorizontalDS;
extern "C" int      HorizontalDT;
extern "C" int      HorizontalDZ;

extern "C" int      YAddress;
extern "C" int      Color;

extern "C" int      UStart;
extern "C" int      VStart;
extern "C" int      SStart;
extern "C" int      TStart;
extern "C" int      SStart8;
extern "C" int      TStart8;
extern "C" int      CStart;
extern "C" int      TextureOfsTable;
extern "C" int      IBufferTable;
extern "C" int      Count;
extern "C" int      HDU8;
extern "C" int      HDV8;
extern "C" int      HDS8;
extern "C" int      HDT8;

// extern "C" float    _tmp_flt;
extern "C" float    _tmp_half;
extern "C" float    _tmp_fixone;
extern "C" float    _tmp_flt_63;
extern "C" float    _tmp_flt_255;
extern "C" float    _tmp_fxd2flt;

extern "C" float    FUDGE_FACTOR;

extern "C" int      LAffU;
extern "C" int      RAffU;
extern "C" int      LAffV;
extern "C" int      RAffV;
extern "C" int      AffDU;
extern "C" int      AffDV;
extern "C" int      DrawWidth;
extern "C" float    hpu;
extern "C" float    hpv;
extern "C" float    hpz;
extern "C" int      SpanCount;
extern "C" float    DivTable[16+1];

void UnshadedPolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientPolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertPolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudPolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongPolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongPolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);


void TransUnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);

#endif
